#if defined(__clang__)
#pragma once
#include "feely_pona_unity.h"
#endif

enum FP_ProfileZone
{
    FP_ProfileZone_FPUpdate = TELY_ProfileZone_Count,
    FP_ProfileZone_FPUpdate_EntityLoop,
    FP_ProfileZone_FPUpdate_PathFinding,
    FP_ProfileZone_FPUpdate_AStar,
    FP_ProfileZone_FPUpdate_AStarEnumerateCollidables,
    FP_ProfileZone_FPUpdate_AStarExpand,
    FP_ProfileZone_FPUpdate_AStarExploreNeighbours,
    FP_ProfileZone_FPUpdate_Attacks,
    FP_ProfileZone_FPRender,
};

struct FP_Meters
{
    Dqn_f32 meters;
};

struct FP_GlobalAnimations
{
    Dqn_String8 airport_terry         = DQN_STRING8("airport_terry");
    Dqn_String8 airport_terry_plane   = DQN_STRING8("airport_terry_plane");

    Dqn_String8 catfish_attack_down   = DQN_STRING8("catfish_attack_down");
    Dqn_String8 catfish_attack_side   = DQN_STRING8("catfish_attack_side");
    Dqn_String8 catfish_attack_up     = DQN_STRING8("catfish_attack_up");
    Dqn_String8 catfish_death         = DQN_STRING8("catfish_death");
    Dqn_String8 catfish_walk_up       = DQN_STRING8("catfish_walk_up");
    Dqn_String8 catfish_walk_side     = DQN_STRING8("catfish_walk_side");
    Dqn_String8 catfish_walk_down     = DQN_STRING8("catfish_walk_down");

    Dqn_String8 clinger_attack_down   = DQN_STRING8("clinger_attack_down");
    Dqn_String8 clinger_attack_side   = DQN_STRING8("clinger_attack_side");
    Dqn_String8 clinger_attack_up     = DQN_STRING8("clinger_attack_up");
    Dqn_String8 clinger_death         = DQN_STRING8("clinger_death");
    Dqn_String8 clinger_walk_up       = DQN_STRING8("clinger_walk_up");
    Dqn_String8 clinger_walk_down     = DQN_STRING8("clinger_walk_down");

    Dqn_String8 church_terry_alive    = DQN_STRING8("church_terry_alive");
    Dqn_String8 church_terry_dark     = DQN_STRING8("church_terry_dark");

    Dqn_String8 club_terry_alive      = DQN_STRING8("club_terry_alive");
    Dqn_String8 club_terry_dark       = DQN_STRING8("club_terry_dark");

    Dqn_String8 heart                 = DQN_STRING8("heart");
    Dqn_String8 heart_bleed           = DQN_STRING8("heart_bleed");

    Dqn_String8 kennel_terry          = DQN_STRING8("kennel_terry");

    Dqn_String8 map                   = DQN_STRING8("map");

    Dqn_String8 merchant_button_a     = DQN_STRING8("merchant_button_a");
    Dqn_String8 merchant_button_b     = DQN_STRING8("merchant_button_b");
    Dqn_String8 merchant_button_x     = DQN_STRING8("merchant_button_x");
    Dqn_String8 merchant_button_y     = DQN_STRING8("merchant_button_y");

    Dqn_String8 merchant_graveyard          = DQN_STRING8("merchant_graveyard");
    Dqn_String8 merchant_graveyard_menu     = DQN_STRING8("merchant_graveyard");
    Dqn_String8 merchant_gym                = DQN_STRING8("merchant_gym");
    Dqn_String8 merchant_gym_menu           = DQN_STRING8("merchant_gym_menu");
    Dqn_String8 merchant_phone_company      = DQN_STRING8("merchant_phone_company");
    Dqn_String8 merchant_phone_company_menu = DQN_STRING8("merchant_phone_company_menu");
    Dqn_String8 merchant_terry              = DQN_STRING8("merchant_terry");
    Dqn_String8 merchant_terry_menu         = DQN_STRING8("merchant_terry_menu");

    Dqn_String8 shadow_long_circle    = DQN_STRING8("shadow_long_circle");
    Dqn_String8 shadow_tight_circle   = DQN_STRING8("shadow_tight_circle");

    Dqn_String8 shrubbery_bush_1      = DQN_STRING8("shrubbery_bush_1");
    Dqn_String8 shrubbery_bush_2      = DQN_STRING8("shrubbery_bush_2");
    Dqn_String8 shrubbery_island_1    = DQN_STRING8("shrubbery_island_1");
    Dqn_String8 shrubbery_island_2    = DQN_STRING8("shrubbery_island_2");
    Dqn_String8 shrubbery_island_3    = DQN_STRING8("shrubbery_island_3");

    Dqn_String8 smoochie_walk_up      = DQN_STRING8("smoochie_walk_up");
    Dqn_String8 smoochie_walk_down    = DQN_STRING8("smoochie_walk_down");
    Dqn_String8 smoochie_walk_left    = DQN_STRING8("smoochie_walk_left");
    Dqn_String8 smoochie_walk_right   = DQN_STRING8("smoochie_walk_right");
    Dqn_String8 smoochie_attack_down  = DQN_STRING8("smoochie_attack_down");
    Dqn_String8 smoochie_hurt_side    = DQN_STRING8("smoochie_hurt_side");
    Dqn_String8 smoochie_attack_heart = DQN_STRING8("smoochie_attack_heart");
    Dqn_String8 smoochie_death        = DQN_STRING8("smoochie_death");

    Dqn_String8 terry_attack_up            = DQN_STRING8("terry_attack_up");
    Dqn_String8 terry_attack_side          = DQN_STRING8("terry_attack_side");
    Dqn_String8 terry_attack_down          = DQN_STRING8("terry_attack_down");
    Dqn_String8 terry_attack_phone_up      = DQN_STRING8("terry_attack_phone_up");
    Dqn_String8 terry_attack_phone_side    = DQN_STRING8("terry_attack_phone_side");
    Dqn_String8 terry_attack_phone_down    = DQN_STRING8("terry_attack_phone_down");
    Dqn_String8 terry_attack_phone_message = DQN_STRING8("terry_attack_phone_message");
    Dqn_String8 terry_walk_idle            = DQN_STRING8("terry_walk_idle");
    Dqn_String8 terry_walk_up              = DQN_STRING8("terry_walk_up");
    Dqn_String8 terry_walk_down            = DQN_STRING8("terry_walk_down");
    Dqn_String8 terry_walk_left            = DQN_STRING8("terry_walk_left");
    Dqn_String8 terry_walk_right           = DQN_STRING8("terry_walk_right");
}
g_anim_names;

